[leetcode]自练:1

版权声明:本文为博主原创文章,未经博主允许不得转载。 https://blog.csdn.net/qq_20032995/article/details/80657850

给定一个整数数组和一个目标值,找出数组中和为目标值的两个数。

你可以假设每个输入只对应一种答案,且同样的元素不能被重复利用。

示例:

给定 nums = [2, 7, 11, 15], target = 9

因为 nums[0] + nums[1] = 2 + 7 = 9
所以返回 [0, 1]

原题

1.直接遍历:

class Solution {
    public int[] twoSum(int[] nums, int target) {
        for(int i = 0; i < nums.length; i++){
            for(int j = i + 1; j < nums.length; j++){
                if(nums[j] == target - nums[i]){
                    return new int[]{i,j};
                }
            }
        }
        throw new IllegalArgumentException("无解");
    }
}

2.一次hash:

class Solution {
    public int[] twoSum(int[] nums, int target) {
        HashMap<Integer,Integer> map = new HashMap();
        for(int i = 0; i < nums.length; i++){
            map.put(nums[i], i);
        }
        for(int j = 0; j < nums.length; j++){
            int res = target - nums[j];
            if(map.containsKey(res) && map.get(res) != j){
                return new int[]{map.get(res), j};
            }
        }
        throw new IllegalArgumentException("无解");
    }
}

3.一次遍历hash:

class Solution {
    public int[] twoSum(int[] nums, int target) {
        HashMap<Integer,Integer> map = new HashMap();
        for(int i = 0; i < nums.length; i++){
            int res = target - nums[i];
            if(map.containsKey(res)){
                return new int[]{map.get(res), i};
            }   
            map.put(nums[i], i);
        }
        throw new IllegalArgumentException("无解");
    }
}

猜你喜欢

转载自blog.csdn.net/qq_20032995/article/details/80657850
今日推荐